// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/PerceptionCameraParameters.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__PERCEPTION_CAMERA_PARAMETERS__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__PERCEPTION_CAMERA_PARAMETERS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/perception_camera_parameters__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const PerceptionCameraParameters & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: stereo_cameras_direction
  {
    out << "stereo_cameras_direction: ";
    rosidl_generator_traits::value_to_yaml(msg.stereo_cameras_direction, out);
    out << ", ";
  }

  // member: left_intrinsics
  {
    if (msg.left_intrinsics.size() == 0) {
      out << "left_intrinsics: []";
    } else {
      out << "left_intrinsics: [";
      size_t pending_items = msg.left_intrinsics.size();
      for (auto item : msg.left_intrinsics) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: right_intrinsics
  {
    if (msg.right_intrinsics.size() == 0) {
      out << "right_intrinsics: []";
    } else {
      out << "right_intrinsics: [";
      size_t pending_items = msg.right_intrinsics.size();
      for (auto item : msg.right_intrinsics) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: rotation_left_in_right
  {
    if (msg.rotation_left_in_right.size() == 0) {
      out << "rotation_left_in_right: []";
    } else {
      out << "rotation_left_in_right: [";
      size_t pending_items = msg.rotation_left_in_right.size();
      for (auto item : msg.rotation_left_in_right) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: translation_left_in_right
  {
    if (msg.translation_left_in_right.size() == 0) {
      out << "translation_left_in_right: []";
    } else {
      out << "translation_left_in_right: [";
      size_t pending_items = msg.translation_left_in_right.size();
      for (auto item : msg.translation_left_in_right) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PerceptionCameraParameters & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: stereo_cameras_direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stereo_cameras_direction: ";
    rosidl_generator_traits::value_to_yaml(msg.stereo_cameras_direction, out);
    out << "\n";
  }

  // member: left_intrinsics
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.left_intrinsics.size() == 0) {
      out << "left_intrinsics: []\n";
    } else {
      out << "left_intrinsics:\n";
      for (auto item : msg.left_intrinsics) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: right_intrinsics
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.right_intrinsics.size() == 0) {
      out << "right_intrinsics: []\n";
    } else {
      out << "right_intrinsics:\n";
      for (auto item : msg.right_intrinsics) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: rotation_left_in_right
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.rotation_left_in_right.size() == 0) {
      out << "rotation_left_in_right: []\n";
    } else {
      out << "rotation_left_in_right:\n";
      for (auto item : msg.rotation_left_in_right) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: translation_left_in_right
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.translation_left_in_right.size() == 0) {
      out << "translation_left_in_right: []\n";
    } else {
      out << "translation_left_in_right:\n";
      for (auto item : msg.translation_left_in_right) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PerceptionCameraParameters & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::PerceptionCameraParameters & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::PerceptionCameraParameters & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::PerceptionCameraParameters>()
{
  return "psdk_interfaces::msg::PerceptionCameraParameters";
}

template<>
inline const char * name<psdk_interfaces::msg::PerceptionCameraParameters>()
{
  return "psdk_interfaces/msg/PerceptionCameraParameters";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::PerceptionCameraParameters>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::PerceptionCameraParameters>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<psdk_interfaces::msg::PerceptionCameraParameters>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__PERCEPTION_CAMERA_PARAMETERS__TRAITS_HPP_
